/*
 * SwingApplication.java is a 1.4 example that requires
 * no other files.
 */
import javax.swing.*;          
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.ArrayList;

//data /totFat, satFat, chol, sodi, pot, totCarb, fiber, prot, totCal, alc,caf, cost, taste, time/;

public class DietInput implements ActionListener {
	public class Food {
		String name;
		double data[];
		int cat;
		
		public Food(String name, int numFields, int cat) {
			this.name = name;
			data = new double[numFields];
			this.cat = cat;
		}
		
		public Food(String name, double[] data, int cat) {
			this.name = name;
			this.data = new double[data.length];
			for(int i = 0; i < data.length; i++) {
				this.data[i] = data[i];
			}
			this.cat = cat;
		}
	}
	
	static final  int MAIN = 0;
	static final int SIDE  = 1;
	static final int DRINK = 2;
	
	static final public  String gamsdir= "C:\\Documents and Settings\\Justin\\My Documents\\gamsdir\\"; 
	static final public String fileName = "food.dat";
	
	ArrayList<Food> foods = new ArrayList<Food>();
	
	String foodName;
	JLabel foodLabel;
	JTextField foodTF;
	
	String[] dataFields= {"totFat", "satFat", "chol", "sodium", "totCarb", "fiber", "protein", "sugars", "totCal", 
									  "alcohol","caffenine",
									 
									  "vitA", "vitB6"," bitB12", "vitC", "vitD", "vitE", "vitK", "biotin", "calcium", "chloride", "copper",
									  "folAcid", "iodine",  "iron",	  "magnesium",  "niacin",  "phos", "potassium", "riboflavin", "selenium",
									  "thiamin", "zinc",
									  									  
									  "cost", "taste", "time",
									  
									  "maxMealAmt", "maxDayAmt", "maxWeekAmt",
									  "maxMeals", "maxDays"};
	
	String[] labelString= {"Total Fat",
										"Saturated Fat",
										"Cholesterol",
										"Sodium",
										"Total Carbs",
										"Fiber",
										"Protein",
										"Sugars",
										"Total Calories",
										"Alcohol",
										"Caffenine",
										
										"Vitamin A",
										"Vitamin B6",
										"Vitamin B12",
										"Vitamin C",
										"Vitamin D",
										"Vitamin E",
										"Vitamin K",
										"Biotin",
										"Calcium",
										"Chloride",
										"Copper",
										"Folic Acid",
										"Iodine",
										"Iron",
										"Magnesium",
										"Niacin",
										"Phosphorus",
										"Potassium",
										"Riboflavin",
										"Selenium",
										"Thiamin",
										"Zinc",
										
										"Cost",
										"Taste",
										"Time",
										
										"Max/Meal",
										"Max/Day",
										"Max/Week",
										"Max Meals/Day",
										"Max Days/Week"};
	
	JLabel [] labels = new JLabel[dataFields.length]; 	
	JTextField[] textFields = new JTextField[dataFields.length];	
	JRadioButton[] radioButtons;
	ButtonGroup group;
	JButton buttonGet, buttonAdd, buttonDone;
	
	
    //Specify the look and feel to use.  Valid values:
    //null (use the default), "Metal", "System", "Motif", "GTK+"
    final static String LOOKANDFEEL = null;

    public Component createComponents() {
    	//INITIALIZE ALL COMPONENTS    	
    	foodLabel = new JLabel("Food");
    	foodTF = new JTextField(5);
    	foodTF.addActionListener(this);
    	
    	for(int i = 0; i < dataFields.length; i++) {
    		//System.out.println(dataFields[i] + " " + labelString[i]);
    		labels[i] = new JLabel(labelString[i]);
    		textFields[i] = new JTextField(5);
    		textFields[i].addActionListener(this);
    	}
    	
    	radioButtons = new JRadioButton[3];
    	group = new ButtonGroup();
    	radioButtons[0] = new JRadioButton("Main Dish");
    	radioButtons[0].setActionCommand("main");
    	//radioButtons[0].addActionListener(this);
    	radioButtons[1] = new JRadioButton("Side Dish");
    	radioButtons[1].setActionCommand("side");
    	//radioButtons[1].addActionListener(this);
    	radioButtons[2] = new JRadioButton("Drink");
    	radioButtons[2].setActionCommand("drink");
    	//radioButtons[2].addActionListener(this);
    	radioButtons[0].setSelected(true);
    	for (int i = 0; i < 3; i++) {
			group.add(radioButtons[i]);
		}
		group.setSelected(radioButtons[0].getModel(), true);
    	
		buttonGet = new JButton("Load");
    	buttonGet.setActionCommand("get");
        buttonGet.addActionListener(this);
        
		buttonAdd = new JButton("Add");
    	buttonAdd.setActionCommand("add");
        buttonAdd.addActionListener(this);
        
        buttonDone = new JButton("Save");
    	buttonDone.setActionCommand("done");
        buttonDone.addActionListener(this);

        // ADD COMPONENTS TO PANE        
        JPanel pane = new JPanel(new GridLayout(0, 6));
        pane.add(foodLabel);
        pane.add(foodTF);
        
        for(int i = 0; i < dataFields.length; i++) {
        	pane.add(labels[i]);
        	pane.add(textFields[i]);
        }
        
        pane.add(new JLabel(""));
        //pane.add(new JLabel(""));
        
        for(int i = 0; i < 3; i++) {
        	pane.add(radioButtons[i]);
    	}
        
        pane.add(buttonGet);
        pane.add(buttonAdd);
        pane.add(buttonDone);
       
        pane.setBorder(BorderFactory.createEmptyBorder( 10, 10, 10, 10)); //(top, left, bottom, right)

        return pane;
    }

    public void actionPerformed(ActionEvent e) {
    	foodName = foodTF.getText();	
    	if("get".equals(e.getActionCommand())) { //GET INFO
			Food f = null;
			for(int i = 0; i < foods.size(); i++) {
    			if(foods.get(i).name.equals(foodName)) {
    				f = foods.get(i);
    				break;
    			}
    		}
			if(f != null) {
				for(int i = 0; i < dataFields.length; i++) {
					if(f.data[i] != 0) {
						textFields[i].setText(String.valueOf(f.data[i]));
					} else {
						textFields[i].setText("");
					}
				}
				group.setSelected(radioButtons[f.cat].getModel(), true);
			} else {
				for(int i = 0; i < dataFields.length; i++) {
					textFields[i].setText("");
				}
			}
		} else if("add".equals(e.getActionCommand())) { //ADD FOOD
			addToFoods();
    	} else if("done".equals(e.getActionCommand())) { //SAVE TO FILE
    		if( Double.valueOf(textFields[8].getText()) != 0) {
    			addToFoods();
    		}
    		writeToFile();
    	}
    }
    
    private void addToFoods() {
		int cat;
		String curRadio = group.getSelection().getActionCommand();    		
		if(curRadio.equals("main")) {
			cat = MAIN;
		} else if(curRadio.equals("side")) {
			cat = SIDE;
		} else {
			cat = DRINK;
		}
		
		Food f = new Food(foodName, dataFields.length, cat);
		
		for(int i = 0; i < foods.size(); i++) {
			if(foods.get(i).name.equals(foodName)) {
				f = foods.remove(i);
				break;
			}
		}
		
		System.out.println("Food = " + foodName + " car: " + cat);
	   for(int i = 0; i < dataFields.length; i++) {
		   try {
			   f.data[i] = Double.valueOf(textFields[i].getText());
		   } catch(Exception ex) { 
			   f.data[i] = 0.0;
		   }
	       System.out.println(labelString[i] + " = " + f.data[i]);
	   }	   
	   foods.add(f);
    }
    
    private void writeToFile() {
    	System.out.println(foods.size());
    	System.out.println("Saving to file " + gamsdir + fileName);
    	File outFile;
    	PrintWriter pw = null;

    	outFile = new File(gamsdir + fileName);
    	if(!outFile.exists()) {
    		try {
    			outFile.createNewFile();
    		} catch (Exception e) {}
    	}
    	try {
    		pw = new PrintWriter(new BufferedWriter(new FileWriter(outFile)));
    	} catch (IOException e) { }
    	
    	//set data
    	pw.print("set data /");
    	for(int i = 0; i < dataFields.length; i++) {
    		pw.print(dataFields[i]);
    		if(i != dataFields.length - 1) pw.print(", ");
    	}
    	pw.println("/;");
    	
    	//set foods
    	pw.print("set foods /");
    	for(int i = 0; i < foods.size(); i++) {
    		pw.print(foods.get(i).name);
    		if(i != foods.size() - 1) pw.print(", ");
    	}
    	pw.println("/;\n");
    	
    	//table food(foods, data)
    	pw.println("table food(foods, data)");
    	pw.printf("%1$12s","");
    	for(int i = 0; i < dataFields.length; i++) {
    		pw.printf("%1$12s", dataFields[i]);
    	}
    	pw.println();
    	for(int i = 0; i < foods.size(); i++) {
    		pw.printf("%1$12s", foods.get(i).name);
    		for(int j = 0; j < dataFields.length; j++) {
    			pw.printf("%1$12.2f", foods.get(i).data[j]);
    		}
    		if(i == foods.size() - 1) pw.print(" ;"); 
    		pw.println();
    	}
    	pw.println();
    	
    	//define subsets mains
    	String outString = "set mains(foods) /";
    	for(int i = 0; i < foods.size(); i++) {
    		if(foods.get(i).cat == MAIN ) {
    			outString += (foods.get(i)).name + ", ";
    		}
    	}
    	if(outString.contains(","))	outString = outString.substring(0, outString.lastIndexOf(","));
    	pw.println(outString + "/;");
    	
    	//subset sides
    	outString = "set sides(foods) /";
    	for(int i = 0; i < foods.size(); i++) {
    		if(foods.get(i).cat == SIDE ) {
    			outString +=( foods.get(i)).name + ", ";
    		}
    	}
    	if(outString.contains(","))	outString = outString.substring(0, outString.lastIndexOf(","));
    	pw.println(outString + "/;");
    	
    	//subset drinks
    	outString = "set drinks(foods) /";
    	for(int i = 0; i < foods.size(); i++) {
    		if(foods.get(i).cat == DRINK ) {
    			outString += (foods.get(i)).name + ", ";
    		}
    	}
    	if(outString.contains(","))	outString = outString.substring(0, outString.lastIndexOf(","));
    	pw.println(outString + "/;");
    	pw.close(); 	
    }
 
    private void loadFile() {
    	MyFileReader fr = null;
    	try {
    		int foodCount;
    		fr = new MyFileReader(gamsdir + fileName, ",/ \t");
    		fr.readLine(); //flush data set info
    		fr.readLine(); //flush food set info
    		fr.readLine(); //flush blank line
    		fr.readLine(); //flush table declaration
    		fr.readLine(); //flush data place holders
    		
    		//read line foods/data
    		String token = "";
    		String line = "";
    		while(!token.equals(";")) {
    			line = fr.readLine();
    			//System.out.println(line);
    			Food fd = new Food(line = fr.nextToken(), dataFields.length, -1);
    			//System.out.println("Food: " + line); 
    			for(int i = 0; fr.hasMoreTokens(); i++) {
    				if((token = fr.nextToken()).equals(";")) break;
    				fd.data[i] = Double.valueOf(token);
    				//System.out.print(dataFields[i] + ": |" + token + "| ");
    			}
    			foods.add(fd);
    		}
    		
    		//fix catergories
    		fr.readLine(); //flush blank line

    		//get main dishes
			fr.readLine();
			fr.nextToken(); fr.nextToken();
			for(int i = 0; fr.hasMoreTokens(); i++) {
				token = fr.nextToken();
				if(token.equals(";")) break;
				for(int j = 0; j < foods.size(); j++) {
					if(token.equals(foods.get(j).name)) {
						foods.get(j).cat = MAIN;
						break;
					}
				}
			}
			
			//get side dishes
			fr.readLine();
			fr.nextToken(); fr.nextToken();
			for(int i = 0; fr.hasMoreTokens(); i++) {
				token = fr.nextToken();
				if(token.equals(";")) break;
				for(int j = 0; j < foods.size(); j++) {
					if(token.equals(foods.get(j).name)) {
						foods.get(j).cat = SIDE;
						break;
					}
				}
			}
			
			//get drinks
			fr.readLine();
			fr.nextToken(); fr.nextToken();
			for(int i = 0; fr.hasMoreTokens(); i++) {
				token = fr.nextToken();
				if(token.equals(";")) break;
				for(int j = 0; j < foods.size(); j++) {
					if(token.equals(foods.get(j).name)) {
						foods.get(j).cat = DRINK;
						break;
					}
				}
			}	
    	} catch(Exception e) { 
    			System.out.println(e.toString());
    			System.exit(0);
    	}
    }
  
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Set the look and feel.
    	try{
    		UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    	} catch(Exception e){ }

        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("Diet Input");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        DietInput app = new DietInput();
        app.loadFile();
        Component contents = app.createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
            	createAndShowGUI();
            }
        });
    }
}

