import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.UIManager;

public class FreeTimeInput implements ActionListener {
	
	static final public  String gamsdir= "C:\\Documents and Settings\\Justin\\My Documents\\gamsdir\\"; 
	static final public String fileName = "freetime.dat";
	
	boolean[] freeTime = new boolean[38 * 7];
	JLabel dayLabel;
	JTextField dayTF;
	
	String[] dataFields = new String[38];
	
	JLabel [] labels = new JLabel[dataFields.length]; 	

	JCheckBox[] checkBoxs = new JCheckBox[dataFields.length];
	
	JButton  buttonGet;
	JButton  buttonAdd;
	JButton  buttonDone;
	
	
    //Specify the look and feel to use.  Valid values:
    //null (use the default), "Metal", "System", "Motif", "GTK+"
    final static String LOOKANDFEEL = null;

    public Component createComponents() {
    	//INITIALIZE ALL COMPONENTS
    	for(int i = 0; i < freeTime.length; i++) {
    		freeTime[i] = true;
    	}
    	
    	dayLabel = new JLabel("Day");
    	dayTF = new JTextField(5);
    	dayTF.addActionListener(this);
    	
    	for(int i = 0;  i < dataFields.length; i++) {
    		System.out.println(String.valueOf(6 + i/2) + ":" + String.valueOf(i * 30 % 60));
    		dataFields[i] = String.valueOf(6 + i/2) + ":" + String.valueOf(i * 30 % 60);
    	}
    	
    	for(int i = 0; i < dataFields.length; i++) {
    		//System.out.println(dataFields[i] + " " + labelString[i]);
    		labels[i] = new JLabel(dataFields[i]);
    		checkBoxs[i] = new JCheckBox();
    		checkBoxs[i].addActionListener(this);
    	}
        
    	buttonGet = new JButton("Get");
    	buttonGet.setActionCommand("get");
        buttonGet.addActionListener(this);
        
    	buttonAdd = new JButton("Add");
    	buttonAdd.setActionCommand("add");
        buttonAdd.addActionListener(this);
        
        buttonDone = new JButton("Done");
    	buttonDone.setActionCommand("done");
        buttonDone.addActionListener(this);

        // ADD COMPONENTS TO PANE        
        JPanel pane = new JPanel(new GridLayout(0, 10));
       
        pane.add(dayLabel);
        pane.add(dayTF);
        
        for(int i = 0; i < dataFields.length; i++) {
        	pane.add(labels[i]);
        	pane.add(checkBoxs[i]);
        }
        
        //pane.add(new JLabel(""));
        //pane.add(new JLabel(""));
        
        pane.add(buttonGet);
        pane.add(buttonAdd);
        pane.add(buttonDone);
       
        pane.setBorder(BorderFactory.createEmptyBorder( 10, 10, 10, 10)); //(top, left, bottom, right)

        return pane;
    }

    public void actionPerformed(ActionEvent e) {
    	if("get".equals(e.getActionCommand())) { // BIG STEAMY LOAD
    		int d = Integer.parseInt(dayTF.getText());
    		for(int i = 0; i < dataFields.length; i++) {
    			checkBoxs[i].setSelected(!freeTime[i + dataFields.length *(d - 1)]);
    		}
    	}
    	if("add".equals(e.getActionCommand())) { //SAVE TO FILE
    		int d = Integer.parseInt(dayTF.getText());
    		for(int i = 0; i < dataFields.length; i++) {
    			freeTime[i + dataFields.length *(d - 1)] = !checkBoxs[i].isSelected();
    		}
    	} else if("done".equals(e.getActionCommand())) { //SAVE TO FILE
    		writeToFile();
    	}
    }
    
    private void writeToFile() {
    	System.out.println("Saving to file " + gamsdir + fileName);
    	File outFile;
    	PrintWriter pw = null;

    	outFile = new File(gamsdir + fileName);
    	System.out.println(gamsdir + fileName);
    	if(!outFile.exists()) {
    		try {
    			outFile.createNewFile();
    		} catch (Exception e) {}
    	}
    	try {
    		pw = new PrintWriter(new BufferedWriter(new FileWriter(outFile)));
    	} catch (IOException e) { }
    	
    	
    	pw.println("table freeTime(days, qhours)");
    	System.out.println("table freeTime(days, qhours)");
    	pw.printf("%1$12s","");
    	for(int i = 0; i < dataFields.length; i++) {
    		System.out.printf("qH" + (i + 1));
    		pw.printf("%1$12s", "qH" + (i + 1));
    	}
    	System.out.println();
    	pw.println();
    	for(int i = 0; i < 7; i++) {
    		//System.out.println("i:" + i);
    		String s = "d" + (i + 1);
    		pw.printf("%1$12s", s);
    		for(int j = 0; j < dataFields.length; j++) {
    			//System.out.println("j:" + j);
    			//System.out.println(j + i * dataFields.length);
    			int k = freeTime[j + i * dataFields.length]?1:0;
    			System.out.printf(k + " ");
    			pw.printf("%1$12d", k);
    		}
    		if(i == 6) pw.print(" ;"); 
    		pw.println();
    	}
    	pw.println();
    	pw.close(); 
    }
  
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Set the look and feel.
    	try{
    		UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    	} catch(Exception e){ }

        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("Free Time Input");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        FreeTimeInput app = new FreeTimeInput();
        //app.loadFile();
        Component contents = app.createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
            	createAndShowGUI();
            }
        });
    }
}
