$title Homework 10 Problem 1
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

scalar  mainPerMeal number of main dishes wanted per meal /.5/,
        sidePerMeal number of side dishes wanted per meal /1/,
        drinkPerMeal number of drinks wanted per meal /1/,

        scalePerMeal importance of accomplishing wanted per meal /10/,
        scaleBalance importance of balanced meals /.14/,
        scaleMaxMealAmt importance of variety in meals /100/,
        scaleMaxDayAmt  importance of variety in meals /100/,
        scaleMaxWeekAmt importance of variety in meals /100/,
        scaleMaxMeals   importance of variety in meals /100/,
        scaleMaxDays    importance of variety in meals /100/,

        timeSlotSize size of each time slot in minutes /30/,
        firstSlotHour first hour of the day that you have free /6/,
        bigM /2/;


*import food information
$offlisting
$include food.dat
$onlisting

set nutris(data) nutrition data
         /totFat, satFat, chol, sodium, totCarb, fiber, protein, sugars, totCal/,
    vitamins(data) vitamin data
         /vitA, vitB6,  bitB12, vitC, vitD, vitE, vitK, biotin, calcium,
         chloride, copper, folAcid, iodine, iron, magnesium, niacin, phos,
         potassium, riboflavin, selenium, thiamin, zinc/,
    amtlimits(data) proposed limits on amount per meal-day-week
         /maxMealAmt, maxDayAmt, maxWeekAmt/,
    xlimits(data) max meals-days you want to eat each food
         /maxMeals, maxDays/,
    others(data) the rest
         /alcohol, caffenine, cost, taste, time/;

*38
set qHours fractional hours of the day /qH1*qH38/,
    days   days of the week /d1*d7/,
    meals  meals each day /m1*m3/;

alias (data,   dt);
alias (foods,  fd);
alias (mains,  mn);
alias (sides,  sd);
alias (drinks, dk);
alias (days,   dy);
alias (meals,  ml);
alias (nutris,  nt);
alias (vitamins,vt);
alias (others,  ot);
alias (amtlimits,  alt);
alias (xlimits,  xlt);
alias (qHours, qH);

set arc(days, meals, dy, qHours);

$offlisting
$include freetime.dat
$onlisting

*extra free time table to demonstrate planning less than 3 meals (NoTime.dat)
*table freeTime(days, qHours)
*         qH1     qH2     qH3     qH4     qH5
*d1       0       1       0       1       0
*d2       1       0       1       0       0
*d3       1       1       0       1       1
*d4       1       0       0       0       1
*d5       0       1       0       1       0
*d6       1       1       1       1       1
*d7       1       1       1       1       1;

arc(days, meals, dy, qHours) = yes$(sameas(days, dy) and freeTime(dy, qHours));

parameter
*        meal 1 indexes 1,5   = 6am - 8am
*        meal 2 indexes 13,17 = 12pm - 2pm
*        meal 3 indexes 25,29 = 6pm - 8pm
         optTimeIndexL(meals) index of earlist time to start each meal
                 /m1 1, m2 13, m3 25/,
         optTimeIndexU(meals) index of latest time to end each meal
                 /m1 5, m2 17, m3 29/,
         dayMin(data) minimum required amount of data element per day
                  /totFat 30, satFat 20, chol 300, sodium 2400,
                   totCarb 300, fiber 25, protein 50, sugars 0, totCal 2000,
                   alcohol 0, caffenine 0, vitA 100, vitB6 100, bitB12 100,
                   vitC 100, vitD 100, vitE 100, vitK 100, biotin 100, calcium 100,
                   chloride 100, copper 100, folAcid 100, iodine 100, iron 100,
                   magnesium 100, niacin 100, phos 100, potassium 100, riboflavin 100,
                   selenium 100, thiamin 100, zinc 100, cost 0, taste 0, time 0,
                   maxMealAmt 0, maxDayAmt 0, maxWeekAmt 0, maxMeals 0/,
         dayMax(data) maximum recommend amount of element per day
                  /totFat 65, satFat 20, chol 300, sodium 2400,
                   totCarb 300, fiber 25, protein 50, sugars 150, totCal 2700,
                   alcohol 1, caffenine 3, vitA 100, vitB6 1000, bitB12 1000,
                   vitC 1000, vitD 100, vitE 100, vitK 100, biotin 1000, calcium 100,
                   chloride 100, copper 100, folAcid 1000, iodine 100, iron 100,
                   magnesium 100, niacin 100, phos 100, potassium 100, riboflavin 100,
                   selenium 100, thiamin 100, zinc 100, cost 0, taste 0,
                   time 0, maxMealAmt 0, maxDayAmt 0, maxWeekAmt 0,
                   maxMeals 0/,
         weight(data) penalty weight of each data aspect of food
                  /totFat 1, satFat 1, chol 1, sodium 1,
                   totCarb 1, fiber 1, protein 1, sugars 1, totCal 1,
                   alcohol 1, caffenine 1, vitA 1, vitB6 1, bitB12 1,
                   vitC 1, vitD 1, vitE 1, vitK 1, biotin .1, calcium 1,
                   chloride .1, copper 1, folAcid 1, iodine .1, iron 1,
                   magnesium 1, niacin 1, phos 1, potassium 1, riboflavin 1,
                   selenium 1, thiamin 1, zinc 1, cost 0, taste 0, time 0,
                   maxMealAmt 0, maxDayAmt 0, maxWeekAmt 0, maxMeals 0/;


free variable
         totalPenalty the total "badness" of the meal schedule;
positive variables
         intake(days, data) total intake of each data element per day,
         dailyIntakePenalty(days, data) total amount of intake over or under the RDA,
         balancePenalty(days, meals) penalty for meals being of unequal size,
         mainPenalty(days, meals) penalty for not having a main course per meal,
         sidePenalty(days, meals) penalty for not having a side dish per meal,
         drinkPenalty(days, meals) penalty for not having somthing to drink per meal,
         mealTimePenalty(days) penalty for meals being off of standard eating times,
         mealMaxAmtPenalty(days, meals, foods) penalty for exceding the max amount of a food wanted in a meal,
         dayMaxAmtPenalty(days, foods) penalty for exceding the max amount of a food wanted in a day,
         weekMaxAmtPenalty(foods) penalty for exceding the max amount of a food wanted in a week,
         maxMealsPenalty(days, foods) penalty for eating a food in more meals in a day than wanted,
         maxDaysPenalty(foods) penalty for eating a food in more days in a week than wanted,
         usagePenalty penalty for eating a food,
         inMeal(days, foods) tells if foods was ate in that day;
binary variable
         x(days, meals, foods) whether or not a food has been consumed in each meal,
         flow(days, meals, dy, qHours) used to fit meals into schedule,
         z(days, meals, dy, qHours) ensures only consequetive time slots for each meal;
positive variable
         amt(days, meals, foods) the amount of each food to eat each day and meal;

equations
*PENALTY EQ
         EQ_intake(days, data),
         EQ_penaltyL(days, data),
         EQ_penaltyU(days, data),
         EQ_obj,
*MEAL EQ
         EQ_limitMain(days, meals),
         EQ_mainDish(days, meals),
         EQ_sideDish(days, meals),
         EQ_drink(days, meals),
         EQ_balancePenaltyU(days, meals),
         EQ_balancePenaltyL(days, meals),
*SCHEDULE EQ
         EQ_fitToSchedule(days, meals),
         EQ_fitToSchedule1(days, meals),
         EQ_mealsAtATime(days, qHours),
         EQ_consectutive1(days, meals, qHours),
         EQ_consectutive2(days, meals, qHours),
         EQ_consectutive3(days, meals),
         EQ_mealTimePenaltyL(days, meals, qHours),
         EQ_mealTimePenaltyU(days, meals, qHours),
*VARITY CONSTRAINTS
         EQ_mealMaxAmtPenalty(days, meals, foods),
         EQ_dayMaxAmtPenalty(days, foods),
         EQ_weekMaxAmtPenalty(foods),
         EQ_inMeal(days, foods),
         EQ_inMeal1(days, foods),
         EQ_inMeal2(days, foods),
         EQ_inMeal3(days, foods),
         EQ_maxMealsPenalty(days, foods),
         EQ_maxDaysPenalty(foods),
         EQ_x1(days, meals, foods),
         EQ_x2;

************** INTAKE/PENALTY CONSTRAINTS *********************
* intake of each data element consumed each day
EQ_intake(days, data)..
         intake(days, data) =e= sum((ml, fd), amt(days, ml, fd) * food(fd, data));

* penalty incurred each day (from not reaching minimum required amount)
EQ_penaltyL(days, data)..
         dailyIntakePenalty(days, data) =g= weight(data) * (dayMin(data) - intake(days, data));

* penalty incurred each day (from exceding maximum recommended amount)
EQ_penaltyU(days, data)..
         dailyIntakePenalty(days, data) =g= weight(data) * (intake(days, data) - dayMax(data));

* sum penalties over entire week
EQ_obj..
         totalPenalty =e= sum((dy,dt), dailyIntakePenalty(dy,dt))
                          + scalePerMeal * sum((dy, ml), mainPenalty(dy, ml)
                                                       + sidePenalty(dy, ml)
                                                       + drinkPenalty(dy, ml))
                          + scaleBalance * sum((dy, ml), balancePenalty(dy, ml))
                          + sum(dy, mealTimePenalty(dy))
                          + scaleMaxMealAmt * sum((dy, ml, fd), mealMaxAmtPenalty(dy, ml, fd))
                          + scaleMaxDayAmt  * sum((dy, fd), dayMaxAmtPenalty(dy, fd))
                          + scaleMaxWeekAmt * sum(fd, weekMaxAmtPenalty(fd))
                          + scaleMaxMeals * sum((dy, fd), maxMealsPenalty(dy, fd))
                          + scaleMaxDays  * sum(fd, maxDaysPenalty(fd))
                          + usagePenalty;

********************* MEAL CONSTRAINTS *************************
* only allow one main dish per meal
EQ_limitMain(days, meals)..
         sum(mn, x(days, meals, mn)) =l= 1;

* want each meal to have so many main dish(s)
EQ_mainDish(days, meals)..
         mainPenalty(days, meals) =g= mainPerMeal - sum(mn, amt(days, meals, mn));

* want each meal to have so many side dish(s)
EQ_sideDish(days, meals)..
         sidePenalty(days, meals) =g= sidePerMeal - sum(sd, amt(days, meals, sd));

* want each meal to have so many drink(s)
EQ_drink(days, meals)..
         drinkPenalty(days, meals) =g= drinkPerMeal - sum(dk, amt(days, meals, dk));

* penalized for uneven meals (each meal be of roughly the same size(calories))
EQ_balancePenaltyU(days, meals)..
         balancePenalty(days, meals) =g=
                                 sum(fd, amt(days, meals, fd) * food(fd, 'totCal'))
                               - sum((fd, ml), amt(days, ml, fd) * food(fd, 'totCal'))/card(meals);

* penalized for uneven meals (each meal be of roughly the same size(calories))
EQ_balancePenaltyL(days, meals)..
         balancePenalty(days, meals) =g=
                                 sum((fd, ml), amt(days, ml, fd) * food(fd, 'totCal'))/card(meals)
                               - sum(fd, amt(days, meals, fd) * food(fd, 'totCal'));

******************* SCHEDULE CONSTRAINTS ***********************
* fit 3 meals into schedule one inmorning, noon, night
* penalty for meals being to close or too far apart
* each meal must be at least 30 minute apart
* meals must be in freetime


*time of meal must fit inside freetime
EQ_fitToSchedule(days, meals)..
         timeSlotSize * sum(qH$arc(days, meals, days, qH), flow(days, meals, days, qH)) =g=
                                  sum(fd, amt(days, meals, fd) * food(fd, 'time'));

* limit freetime consumed to a minimum
EQ_fitToSchedule1(days, meals)..
         timeSlotSize * sum(qH$arc(days, meals, days, qH), flow(days, meals, days, qH)) =l=
                                  sum(fd, amt(days, meals, fd) * food(fd, 'time'))
                                  + (timeSlotSize - .1);

*ensure only one meal per free time
EQ_mealsAtATime(days, qHours)..
         sum(ml$arc(days, ml, days, qHours), flow(days, ml, days, qHours)) =l= 1;


*ensure meals take up only consequtive time slots
EQ_consectutive1(days, meals, qHours)..
         z(days, meals, days, qHours) =g= flow(days, meals, days, qHours) -
                                          flow(days, meals, days, qHours + 1);
EQ_consectutive2(days, meals, qHours)..
         z(days, meals, days, qHours) =g= flow(days, meals, days, qHours + 1) -
                                          flow(days, meals, days, qHours);
EQ_consectutive3(days, meals)..
         sum(qH, z(days, meals, days, qH)) =l= 2;

* penalize for meals being off of normal eating times
* want meals at morning, noon, and night (7-8am, 12pm, 6-7pm)
EQ_mealTimePenaltyL(days, meals, qHours)..
        mealTimePenalty(days) =g=  z(days, meals, days, qHours) *
                         (optTimeIndexL(meals) - ord(qHours));

EQ_mealTimePenaltyU(days, meals, qHours)..
        mealTimePenalty(days) =g=  z(days, meals, days, qHours) *
                         (ord(qHours)- optTimeIndexU(meals));

********************* VARITY CONSTRAINTS ************************

* penailized food repition (in a meal)
EQ_mealMaxAmtPenalty(days, meals, foods)..
         mealMaxAmtPenalty(days, meals, foods) =g=
                         amt(days, meals, foods) - food(foods, 'maxMealAmt');

* penailized food repition (in a day)
EQ_dayMaxAmtPenalty(days, foods)..
         dayMaxAmtPenalty(days, foods) =g=
                         sum(ml, amt(days, ml, foods)) - food(foods, 'maxDayAmt');

* penailized food repition (in a week)
EQ_weekMaxAmtPenalty(foods)..
         weekMaxAmtPenalty(foods) =g=
                         sum((dy, ml), amt(dy, ml, foods)) - food(foods, 'maxWeekAmt');

* penailized food repition in mutliple meals in a day
EQ_maxMealsPenalty(days, foods)..
         maxMealsPenalty(days, foods) =g=
                         sum(ml, x(days, ml, foods)) - food(foods, 'maxMeals');


* determine if food was consumed in any meal of the particular day
EQ_inMeal(days, foods)..
         inMeal(days, foods) =l= 1;

EQ_inMeal1(days, foods)..
         inMeal(days, foods) =g= x(days, 'm1', foods);

EQ_inMeal2(days, foods)..
         inMeal(days, foods) =g= x(days, 'm2', foods);

EQ_inMeal3(days, foods)..
         inMeal(days, foods) =g= x(days, 'm3', foods);


* penailized food repition on multiple days in the week
EQ_maxDaysPenalty(foods)..
         maxDaysPenalty(foods) =g=
                         sum(dy, inMeal(dy, foods)) - food(foods, 'maxDays');

* set binarys of foods consumed each meal
EQ_x1(days, meals, foods)..
         amt(days, meals, foods) =l= x(days, meals, foods) * bigM;

* penalize for all foods consumed (limit superflous foods)
EQ_x2..
         usagePenalty =e= 0.001 * sum((dy, ml, fd), x(dy, ml, fd));


model diet/all/;
diet.optcr = .15;
solve diet using mip minimizing totalPenalty;


******** listing display ***********
display totalPenalty.l;
display intake.l;
*display dailyIntakePenalty.l;
display mainPenalty.l;
display sidePenalty.l;
display drinkPenalty.l;
display balancePenalty.l;
display amt.l;
display x.l;
*option arc:0:2:2;
*display arc;
*option flow:0:2:2;
*display flow.l;
display mealMaxAmtPenalty.l;
display dayMaxAmtPenalty.l;
display weekMaxAmtPenalty.l;
display maxMealsPenalty.l;
display maxDaysPenalty.l;

************ WRITE TO FILE ******************
parameter startTime(days, meals),
          endTime(days, meals);
startTime(days, meals) = 10000;
endTime(days, meals) = 0;
loop((dy, ml),
         loop(qH$arc(dy,ml,dy,qH),
                 if(flow.l(dy, ml, dy, qH) = 1,
                         if(ord(qH) < startTime(dy, ml),
                                 startTime(dy, ml) = ord(qH);
                         );
                         if(ord(qH) > endTime(dy, ml),
                                 endTime(dy, ml) = ord(qH);
                         );
                 );
         );
);

file schedule /schedule.dat/;
put schedule;
scalar time, cost, taste;
put 'Weekly Meal Schedule'//;
loop(dy,
         put ' ========== Day',ord(dy):2:0,' =========='/;
         loop(ml,
                 time = sum(fd, amt.l(dy, ml, fd) * food(fd, 'time'));
                 put @3, 'Meal', ord(ml):2:0, @13, 'From',
                     @18, startTime(dy, ml):3:0, ' to ', endTime(dy, ml):3:0,
                     ' Time: ', time:5:2/;
                 put @6, 'Drink(s)'/;
                 loop(dk,
                         if(x.l(dy, ml, dk) = 1,
                                 put @9, dk.tl, @16, amt.l(dy, ml, dk)/;
                         );
                 );
                 put @6, 'Main Dish(s)'/;
                 loop(mn,
                         if(x.l(dy, ml, mn) = 1,
                                 put @9, mn.tl, @16, amt.l(dy, ml, mn)/;
                         );
                 );
                 put @6, 'Side(s)'/;
                 loop(sd,
                         if(x.l(dy, ml, sd) = 1,
                                 put @9, sd.tl, @16, amt.l(dy, ml, sd)/;
                         );
                 );
                 cost = sum(fd, amt.l(dy, ml, fd) * food(fd, 'cost'));
                 taste = sum(fd, amt.l(dy, ml, fd) * food(fd, 'taste'))/
                         sum(fd, x.l(dy, ml, fd));
                 put @3, 'Cost', cost:5:2, @13, 'Avg. Taste: ', taste:7:3/;
                 put /;
         );
);


parameter avgDev(data);
put /'Avg. Deviation From RDA over Week'/;
loop(dt$(nutris(dt) or vitamins(dt)),
         avgDev(dt) = sum(dy, dailyIntakePenalty.l(dy, dt)/weight(dt))/card(days);
         put @3, dt.tl, @9, avgDev(dt)/;
);


scalar balancePen;
put /'Meal Size Avg. Balance Penalties'/;
loop(dy,
         balancePen = sum(ml, balancePenalty.l(dy, ml))/card(meals);
         put @3, 'Day', ord(dy):2:0, @9, balancePen:7:4/;
);

scalar mealMaxAmt,
       dayMaxAmt,
       weekMaxAmt,
       mealsMax,
       daysMax;

put /'Food Limit Penalties'/;
loop(fd,
         mealMaxAmt = sum((dy, ml), mealMaxAmtPenalty.l(dy, ml, fd));
         dayMaxAmt  = sum((dy), dayMaxAmtPenalty.l(dy, fd));
         weekMaxAmt = weekMaxAmtPenalty.l(fd);
         mealsMax   = sum(dy, maxMealsPenalty.l(dy, fd));
         daysMax    = maxDaysPenalty.l(fd);

         if((mealMaxAmt + dayMaxAmt + weekMaxAmt + mealsMax + daysMax) > 0,
                 put @3, fd.tl/;
                 if(mealMaxAmt > 0,
                         put @7, 'Amt/Meal',   @18, mealMaxAmt:10:4/;
                 );
                 if(dayMaxAmt > 0,
                         put @7, 'Amt/Day',    @18, dayMaxAmt:10:4/;
                 );
                 if(weekMaxAmt > 0,
                         put @7, 'Amt/Week',   @18, weekMaxAmt:10:4/;
                 );
                 if(mealsMax > 0,
                         put @7, '#Meals/Day', @18, mealsMax:10:4/;
                 );
                 if(daysMax > 0,
                         put @7, '#Days/Week', @18, daysMax:10:4/;
                 );
         );
);

put /'3 Part Meal Penalties'/;
loop((dy, ml),
         if((mainPenalty.l(dy, ml) + sidePenalty.l(dy, ml) + drinkPenalty.l(dy, ml)) > 0,
                 put @3, 'Day', ord(dy):2:0, 'Meal', ord(ml):2:0/;
                 if(drinkPenalty.l(dy, ml) > 0,
                         put @7, 'Drink', @18, drinkPenalty.l(dy, ml):6:4/;
                 );
                 if(mainPenalty.l(dy, ml) > 0,
                         put @7, 'Main', @18, mainPenalty.l(dy, ml):6:4/;
                 );
                 if(sidePenalty.l(dy, ml) > 0,
                         put @7, 'Side', @18, sidePenalty.l(dy, ml):6:4/;
                 );
         );
);


putclose schedule;
